local addonName, L = ...;

-- Function to disable Blizzards Join Match button, this is no real ArenaLiveCore handler:
local DISABLED_TIME = 70;
local CheckFrame = CreateFrame("Frame", "ALSpec_JoinButtonDisabler");

local function EnableJoinButton()
	CheckFrame:SetScript("OnUpdate", nil);
	CheckFrame.disabled = nil;
	PVPReadyDialogEnterBattleButton:Enable();
end

local function OnUpdate(self, elapsed)
	if ( CheckFrame.disabled ) then
		CheckFrame.disabled = CheckFrame.disabled - elapsed;
		if ( CheckFrame.disabled <= 0 ) then
			EnableJoinButton();
		end
	end
end

local function DisableJoinButton()
	CheckFrame.disabled = DISABLED_TIME;
	CheckFrame:SetScript("OnUpdate", OnUpdate);
	PVPReadyDialogEnterBattleButton:Disable();
end

local function hook(self)

	local index = PVPReadyDialog.activeIndex;
	local status, mapName, teamSize, registeredMatch, suspendedQueue, queueType, gameType, role = GetBattlefieldStatus(index);
	local isEnabled = ArenaLiveCore:GetDBEntry(addonName, "DisableQueueButton");
	if ( isEnabled and queueType == "WARGAME" ) then
		DisableJoinButton()
	end
	
end

hooksecurefunc("PVPReadyDialog_Display", hook);